Index: /branches/comu-ver2/data/module/Net/UserAgent/Mobile/DoCoMo.php
===================================================================
--- /branches/comu-ver2/data/module/Net/UserAgent/Mobile/DoCoMo.php	(revision 17140)
+++ /branches/comu-ver2/data/module/Net/UserAgent/Mobile/DoCoMo.php	(revision 18188)
@@ -5,18 +5,36 @@
  * PHP versions 4 and 5
  *
- * LICENSE: This source file is subject to version 3.0 of the PHP license
- * that is available through the world-wide-web at the following URI:
- * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
- * the PHP License and are unable to obtain it through the web, please
- * send a note to license@php.net so we can mail you a copy immediately.
+ * Copyright (c) 2003-2009 KUBO Atsuhiro <kubo@iteman.jp>,
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *     * Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *     * Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in the
+ *       documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
  *
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2008 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
  * @version    CVS: $Id$
  * @link       http://www.nttdocomo.co.jp/service/imode/make/content/spec/useragent/index.html
- * @see        Net_UserAgent_Mobile_Common
+ * @link       http://www.nttdocomo.co.jp/service/imode/make/content/browser/browser2/useragent/index.html
  * @since      File available since Release 0.1
  */
@@ -24,5 +42,5 @@
 require_once dirname(__FILE__) . '/Common.php';
 require_once dirname(__FILE__) . '/Display.php';
-require_once dirname(__FILE__) . '/DoCoMoDisplayMap.php';
+require_once dirname(__FILE__) . '/../Mobile.php';
 
 // {{{ Net_UserAgent_Mobile_DoCoMo
@@ -31,7 +49,6 @@
  * NTT DoCoMo implementation
  *
- * Net_UserAgent_Mobile_DoCoMo is a subclass of
- * {@link Net_UserAgent_Mobile_Common}, which implements NTT docomo i-mode
- * user agents.
+ * Net_UserAgent_Mobile_DoCoMo is a subclass of {@link Net_UserAgent_Mobile_Common},
+ * which implements NTT docomo i-mode user agents.
  *
  * SYNOPSIS:
@@ -74,10 +91,10 @@
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2008 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
- * @version    Release: 0.31.0
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
+ * @version    Release: 1.0.0
  * @link       http://www.nttdocomo.co.jp/service/imode/make/content/spec/useragent/index.html
- * @see        Net_UserAgent_Mobile_Common
+ * @link       http://www.nttdocomo.co.jp/service/imode/make/content/browser/browser2/useragent/index.html
  * @since      Class available since Release 0.1
  */
@@ -145,4 +162,394 @@
     var $_displayBytes;
 
+    /**
+     * The model names which have GPS capability.
+     *
+     * @var array
+     * @since Property available since Release 1.0.0RC1
+     */
+    var $_gpsModels = array('F884i',
+                            'F801i',
+                            'F905iBiz',
+                            'SO905iCS',
+                            'N905iBiz',
+                            'N905imyu',
+                            'SO905i',
+                            'F905i',
+                            'P905i',
+                            'N905i',
+                            'D905i',
+                            'SH905i',
+                            'P904i',
+                            'D904i',
+                            'F904i',
+                            'N904i',
+                            'SH904i',
+                            'F883iESS',
+                            'F883iES',
+                            'F903iBSC',
+                            'SO903i',
+                            'F903i',
+                            'D903i',
+                            'N903i',
+                            'P903i',
+                            'SH903i',
+                            'SA800i',
+                            'SA702i',
+                            'SA700iS',
+                            'F505iGPS',
+                            'F661i',
+                            'F884iES',
+                            'N906iL',
+                            'P906i',
+                            'SO906i',
+                            'SH906i',
+                            'N906imyu',
+                            'F906i',
+                            'N906i',
+                            'F01A',
+                            'F03A',
+                            'F06A',
+                            'F05A',
+                            'P01A',
+                            'P02A',
+                            'SH01A',
+                            'SH02A',
+                            'SH03A',
+                            'SH04A',
+                            'N01A',
+                            'N02A',
+                            'P07A3',
+                            'N06A3',
+                            'N08A3',
+                            'P08A3',
+                            'P09A3',
+                            'N09A3',
+                            'F09A3',
+                            'SH05A3',
+                            'SH06A3',
+                            'SH07A3'
+                            );
+
+    /**
+     * The HTML versions which maps models to HTML versions.
+     *
+     * @var array
+     * @since Property available since Release 1.0.0RC1
+     */
+    var $_htmlVersions = array(
+        'D501i' => '1.0',
+        'F501i' => '1.0',
+        'N501i' => '1.0',
+        'P501i' => '1.0',
+        'D502i' => '2.0',
+        'F502i' => '2.0',
+        'N502i' => '2.0',
+        'P502i' => '2.0',
+        'NM502i' => '2.0',
+        'SO502i' => '2.0',
+        'F502it' => '2.0',
+        'N502it' => '2.0',
+        'SO502iWM' => '2.0',
+        'SH821i' => '2.0',
+        'N821i' => '2.0',
+        'P821i' => '2.0',
+        'D209i' => '2.0',
+        'ER209i' => '2.0',
+        'F209i' => '2.0',
+        'KO209i' => '2.0',
+        'N209i' => '2.0',
+        'P209i' => '2.0',
+        'P209iS' => '2.0',
+        'R209i' => '2.0',
+        'P651ps' => '2.0',
+        'R691i' => '2.0',
+        'F210i' => '2.0',
+        'N210i' => '2.0',
+        'P210i' => '2.0',
+        'KO210i' => '2.0',
+        'F671i' => '2.0',
+        'D210i' => '3.0',
+        'SO210i' => '3.0',
+        'F503i' => '3.0',
+        'F503iS' => '3.0',
+        'P503i' => '3.0',
+        'P503iS' => '3.0',
+        'N503i' => '3.0',
+        'N503iS' => '3.0',
+        'SO503i' => '3.0',
+        'SO503iS' => '3.0',
+        'D503i' => '3.0',
+        'D503iS' => '3.0',
+        'F211i' => '3.0',
+        'D211i' => '3.0',
+        'N211i' => '3.0',
+        'N211iS' => '3.0',
+        'P211i' => '3.0',
+        'P211iS' => '3.0',
+        'SO211i' => '3.0',
+        'R211i' => '3.0',
+        'SH251i' => '3.0',
+        'SH251iS' => '3.0',
+        'R692i' => '3.0',
+        'N2001' => '3.0',
+        'N2002' => '3.0',
+        'P2002' => '3.0',
+        'D2101V' => '3.0',
+        'P2101V' => '3.0',
+        'SH2101V' => '3.0',
+        'T2101V' => '3.0',
+        'D504i' => '4.0',
+        'F504i' => '4.0',
+        'F504iS' => '4.0',
+        'N504i' => '4.0',
+        'N504iS' => '4.0',
+        'SO504i' => '4.0',
+        'P504i' => '4.0',
+        'P504iS' => '4.0',
+        'D251i' => '4.0',
+        'D251iS' => '4.0',
+        'F251i' => '4.0',
+        'N251i' => '4.0',
+        'N251iS' => '4.0',
+        'P251iS' => '4.0',
+        'F671iS' => '4.0',
+        'F212i' => '4.0',
+        'SO212i' => '4.0',
+        'F661i' => '4.0',
+        'F672i' => '4.0',
+        'SO213i' => '4.0',
+        'SO213iS' => '4.0',
+        'SO213iWR' => '4.0',
+        'F2051' => '4.0',
+        'N2051' => '4.0',
+        'P2102V' => '4.0',
+        'F2102V' => '4.0',
+        'N2102V' => '4.0',
+        'N2701' => '4.0',
+        'NM850iG' => '4.0',
+        'NM705i' => '4.0',
+        'NM706i' => '4.0',
+        'D505i' => '5.0',
+        'SO505i' => '5.0',
+        'SH505i' => '5.0',
+        'N505i' => '5.0',
+        'F505i' => '5.0',
+        'P505i' => '5.0',
+        'D505iS' => '5.0',
+        'P505iS' => '5.0',
+        'N505iS' => '5.0',
+        'SO505iS' => '5.0',
+        'SH505iS' => '5.0',
+        'F505iGPS' => '5.0',
+        'D252i' => '5.0',
+        'SH252i' => '5.0',
+        'P252i' => '5.0',
+        'N252i' => '5.0',
+        'P252iS' => '5.0',
+        'D506i' => '5.0',
+        'F506i' => '5.0',
+        'N506i' => '5.0',
+        'P506iC' => '5.0',
+        'SH506iC' => '5.0',
+        'SO506iC' => '5.0',
+        'N506iS' => '5.0',
+        'SO506i' => '5.0',
+        'SO506iS' => '5.0',
+        'N506iS2' => '5.0',
+        'D253i' => '5.0',
+        'N253i' => '5.0',
+        'P253i' => '5.0',
+        'D253iWM' => '5.0',
+        'P253iS' => '5.0',
+        'P213i' => '5.0',
+        'F900i' => '5.0',
+        'N900i' => '5.0',
+        'P900i' => '5.0',
+        'SH900i' => '5.0',
+        'F900iT' => '5.0',
+        'P900iV' => '5.0',
+        'N900iS' => '5.0',
+        'D900i' => '5.0',
+        'F900iC' => '5.0',
+        'N900iL' => '5.0',
+        'N900iG' => '5.0',
+        'F880iES' => '5.0',
+        'SH901iC' => '5.0',
+        'F901iC' => '5.0',
+        'N901iC' => '5.0',
+        'D901i' => '5.0',
+        'P901i' => '5.0',
+        'SH901iS' => '5.0',
+        'F901iS' => '5.0',
+        'D901iS' => '5.0',
+        'P901iS' => '5.0',
+        'N901iS' => '5.0',
+        'P901iTV' => '5.0',
+        'F700i' => '5.0',
+        'SH700i' => '5.0',
+        'N700i' => '5.0',
+        'P700i' => '5.0',
+        'F700iS' => '5.0',
+        'SH700iS' => '5.0',
+        'SA700iS' => '5.0',
+        'SH851i' => '5.0',
+        'P851i' => '5.0',
+        'F881iES' => '5.0',
+        'D701i' => '5.0',
+        'N701i' => '5.0',
+        'P701iD' => '5.0',
+        'D701iWM' => '5.0',
+        'N701iECO' => '5.0',
+        'SA800i' => '5.0',
+        'L600i' => '5.0',
+        'N600i' => '5.0',
+        'L601i' => '5.0',
+        'M702iS' => '5.0',
+        'M702iG' => '5.0',
+        'L602i' => '5.0',
+        'F902i' => '6.0',
+        'D902i' => '6.0',
+        'N902i' => '6.0',
+        'P902i' => '6.0',
+        'SH902i' => '6.0',
+        'SO902i' => '6.0',
+        'SH902iS' => '6.0',
+        'P902iS' => '6.0',
+        'N902iS' => '6.0',
+        'D902iS' => '6.0',
+        'F902iS' => '6.0',
+        'SO902iWP+' => '6.0',
+        'SH902iSL' => '6.0',
+        'N902iX' => '6.0',
+        'N902iL' => '6.0',
+        'P702i' => '6.0',
+        'N702iD' => '6.0',
+        'F702iD' => '6.0',
+        'SH702iD' => '6.0',
+        'D702i' => '6.0',
+        'SO702i' => '6.0',
+        'D702iBCL' => '6.0',
+        'SA702i' => '6.0',
+        'SH702iS' => '6.0',
+        'N702iS' => '6.0',
+        'P702iD' => '6.0',
+        'D702iF' => '6.0',
+        'D851iWM' => '6.0',
+        'F882iES' => '6.0',
+        'N601i' => '6.0',
+        'D800iDS' => '6.0',
+        'P703imyu' => '6.0',
+        'F883i' => '6.0',
+        'F883iS' => '6.0',
+        'P704imyu' => '6.0',
+        'L704i' => '6.0',
+        'L705i' => '6.0',
+        'L705iX' => '6.0',
+        'L852i' => '6.0',
+        'L706ie' => '6.0',
+        'L01A' => '6.0',
+        'L03A' => '6.0',
+        'SH903i' => '7.0',
+        'P903i' => '7.0',
+        'N903i' => '7.0',
+        'D903i' => '7.0',
+        'F903i' => '7.0',
+        'SO903i' => '7.0',
+        'D903iTV' => '7.0',
+        'F903iX' => '7.0',
+        'P903iTV' => '7.0',
+        'SH903iTV' => '7.0',
+        'F903iBSC' => '7.0',
+        'P903iX' => '7.0',
+        'SO903iTV' => '7.0',
+        'N703iD' => '7.0',
+        'F703i' => '7.0',
+        'P703i' => '7.0',
+        'D703i' => '7.0',
+        'SH703i' => '7.0',
+        'N703imyu' => '7.0',
+        'SO703i' => '7.0',
+        'SH904i' => '7.0',
+        'N904i' => '7.0',
+        'F904i' => '7.0',
+        'D904i' => '7.0',
+        'P904i' => '7.0',
+        'SO704i' => '7.0',
+        'F704i' => '7.0',
+        'N704imyu' => '7.0',
+        'SH704i' => '7.0',
+        'D704i' => '7.0',
+        'P704i' => '7.0',
+        'F883iES' => '7.0',
+        'F883iESS' => '7.0',
+        'F801i' => '7.0',
+        'F705i' => '7.0',
+        'D705i' => '7.0',
+        'D705imyu' => '7.0',
+        'SH705i' => '7.0',
+        'SH705i2' => '7.0',
+        'SH706ie' => '7.0',
+        'F05A' => '7.0',
+        'SH905i' => '7.1',
+        'D905i' => '7.1',
+        'N905i' => '7.1',
+        'P905i' => '7.1',
+        'F905i' => '7.1',
+        'SO905i' => '7.1',
+        'N905imyu' => '7.1',
+        'N905iBiz' => '7.1',
+        'SH905iTV' => '7.1',
+        'SO905iCS' => '7.1',
+        'F905iBiz' => '7.1',
+        'P905iTV' => '7.1',
+        'P705i' => '7.1',
+        'N705i' => '7.1',
+        'N705imyu' => '7.1',
+        'P705imyu' => '7.1',
+        'SO705i' => '7.1',
+        'P705iCL' => '7.1',
+        'F884i' => '7.1',
+        'F884iES' => '7.1',
+        'N906iL' => '7.1',
+        'N706i' => '7.1',
+        'SO706i' => '7.1',
+        'P706imyu' => '7.1',
+        'N706ie' => '7.1',
+        'N706i2' => '7.1',
+        'N03A' => '7.1',
+        'N05A' => '7.1',
+        'F07A' => '7.1',
+        'P906i' => '7.2',
+        'SO906i' => '7.2',
+        'SH906i' => '7.2',
+        'N906imyu' => '7.2',
+        'F906i' => '7.2',
+        'N906i' => '7.2',
+        'SH906iTV' => '7.2',
+        'F706i' => '7.2',
+        'SH706i' => '7.2',
+        'P706ie' => '7.2',
+        'SH706iw' => '7.2',
+        'F01A' => '7.2',
+        'F02A' => '7.2',
+        'F03A' => '7.2',
+        'F04A' => '7.2',
+        'F06A' => '7.2',
+        'P01A' => '7.2',
+        'P02A' => '7.2',
+        'P03A' => '7.2',
+        'P04A' => '7.2',
+        'P05A' => '7.2',
+        'P06A' => '7.2',
+        'SH01A' => '7.2',
+        'SH02A' => '7.2',
+        'SH03A' => '7.2',
+        'SH04A' => '7.2',
+        'N01A' => '7.2',
+        'N02A' => '7.2',
+        'N04A' => '7.2',
+        'P10A' => '7.2',
+                               );
+
     /**#@-*/
 
@@ -171,5 +578,5 @@
      *
      * @param string $userAgent User-Agent string
-     * @return mixed void, or a PEAR error object on error
+     * @throws Net_UserAgent_Mobile_Error
      */
     function parse($userAgent)
@@ -188,5 +595,5 @@
             // DoCoMo/2.0 N2001(c10;ser0123456789abcde;icc01234567890123456789)
             $this->_isFOMA = true;
-            list($this->name, $this->version) = explode('/', $main);
+            @list($this->name, $this->version) = explode('/', $main);
             $result = $this->_parseFOMA($foma_or_comment);
         } else {
@@ -207,18 +614,18 @@
      * create a new {@link Net_UserAgent_Mobile_Display} class instance
      *
-     * @return object a newly created {@link Net_UserAgent_Mobile_Display}
-     *     object
-     * @see Net_UserAgent_Mobile_Display
-     * @see Net_UserAgent_Mobile_DoCoMoDisplayMap::get()
+     * @return Net_UserAgent_Mobile_Display
      */
     function makeDisplay()
     {
-        $display = Net_UserAgent_Mobile_DoCoMoDisplayMap::get($this->getModel());
+        include_once dirname(__FILE__) . '/DoCoMo/ScreenInfo.php';
+
+        $screenInfo = &Net_UserAgent_Mobile_DoCoMo_ScreenInfo::singleton();
+        $display = $screenInfo->get($this->getModel());
         if (!is_null($this->_displayBytes)) {
-            list($widthBytes, $heightBytes) =
-                explode('*', $this->_displayBytes);
+            @list($widthBytes, $heightBytes) = explode('*', $this->_displayBytes);
             $display['width_bytes']  = $widthBytes;
             $display['height_bytes'] = $heightBytes;
         }
+
         return new Net_UserAgent_Mobile_Display($display);
     }
@@ -228,5 +635,5 @@
 
     /**
-     * returns supported HTML version like '3.0'. retuns null if unknown.
+     * Gets the HTML version like '3.0'. Returns null if unknown.
      *
      * @return string
@@ -234,25 +641,5 @@
     function getHTMLVersion()
     {
-        static $htmlVersionMap;
-        if (!isset($htmlVersionMap)) {
-            $htmlVersionMap = array(
-                                    '[DFNP]501i' => '1.0',
-                                    '502i|821i|209i|651|691i|(F|N|P|KO)210i|^F671i$' => '2.0',
-                                    '(D210i|SO210i)|503i|211i|SH251i|692i|200[12]|2101V' => '3.0',
-                                    '504i|251i|^F671iS$|212i|2051|2102V|661i|2701|672i|SO213i|850i' => '4.0',
-                                    'eggy|P751v' => '3.2',
-                                    '505i|252i|900i|506i|880i|253i|P213i|901i|700i|^(SH|P)851i|701i|881i|^SA800i$|600i|^L601i$|^M702i(S|G)$|^L602i$' => '5.0',
-                                    '902i|702i|851i|882i|^N601i$|^D800iDS$|^P703imyu$|^P704imyu$|^L70[45]i$|^F883i$' => '6.0',
-                                    '903i|703i|904i|704i|883i|801i|^[FD]705i' => '7.0',
-                                    '905i|705i' => '7.1'
-                                    );
-        }
-
-        foreach ($htmlVersionMap as $key => $value) {
-            if (preg_match("/$key/", $this->_rawModel)) {
-                return $value;
-            }
-        }
-        return null;
+        return @$this->_htmlVersions[ $this->getModel() ];
     }
 
@@ -271,9 +658,5 @@
         }
 
-        static $defaultCacheSize;
-        if (!isset($defaultCacheSize)) {
-            $defaultCacheSize = 5;
-        }
-        return $defaultCacheSize;
+        return 5;
     }
 
@@ -288,5 +671,5 @@
     function getSeries()
     {
-        if ($this->isFOMA() && preg_match('/(\d{4})/', $this->_rawModel)) {
+        if (preg_match('/(\d{4})/', $this->_rawModel)) {
             return 'FOMA';
         }
@@ -299,6 +682,4 @@
             return '651';
         }
-
-        return null;
     }
 
@@ -316,6 +697,4 @@
             return $matches[1];
         }
-
-        return null;
     }
 
@@ -412,13 +791,11 @@
 
     /**
+     * Returns whether a user agent is a GPS model or not.
+     *
      * @return boolean
      */ 
     function isGPS()
     {
-        static $gpsModels;
-        if (!isset($gpsModels)) {
-            $gpsModels = array('F661i', 'F505iGPS');
-        }
-        return in_array($this->_rawModel, $gpsModels);
+        return in_array($this->_rawModel, $this->_gpsModels);
     }
 
@@ -447,4 +824,34 @@
     {
         return 'DoCoMo';
+    }
+
+    // }}}
+    // {{{ getUID()
+
+    /**
+     * Gets the UID of a subscriber.
+     *
+     * @return string
+     * @since Method available since Release 1.0.0RC1
+     */
+    function getUID()
+    {
+        if (array_key_exists('HTTP_X_DCMGUID', $_SERVER)) {
+            return $_SERVER['HTTP_X_DCMGUID'];
+        }
+    }
+
+    // }}}
+    // {{{ getBrowserVersion()
+
+    /**
+     * Gets the i-mode browser version.
+     *
+     * @return string
+     * @since Method available since Release 1.0.0RC3
+     */
+    function getBrowserVersion()
+    {
+        return $this->getCacheSize() == 500 ? '2.0' : '1.0';
     }
 
@@ -462,5 +869,5 @@
      *
      * @param string $main main part of HTTP_USER_AGENT string
-     * @return mixed void, or a PEAR error object on error
+     * @throws Net_UserAgent_Mobile_Error
      */ 
     function _parseMain($main)
@@ -509,5 +916,5 @@
      *
      * @param string $foma main part of HTTP_USER_AGENT string
-     * @return mixed void, or a PEAR error object on error
+     * @throws Net_UserAgent_Mobile_Error
      */ 
     function _parseFOMA($foma)
@@ -522,8 +929,14 @@
         }
 
-        if (preg_match('/^[^(\s]+\s?\((.*?)\)$/', $foma, $matches)) {
+        if (preg_match('/^[^(\s]+\s?\(([^)]+)\)(?:\(([^)]+)\))?$/', $foma, $matches)) {
             if (preg_match('/^compatible/', $matches[1])) { // The user-agent is DoCoMo compatible.
                 $this->_comment = $matches[1];
                 return;
+            }
+
+            if (count($matches) == 3) {
+                if (preg_match('/^compatible/', $matches[2])) { // The user-agent is DoCoMo compatible.
+                    $this->_comment = $matches[2];
+                }
             }
 
@@ -538,5 +951,5 @@
                     continue;
                 }
-                if (preg_match('/^(T[CDBJ])$/', $value, $matches)) {
+                if (preg_match('/^([A-Z]+)$/', $value, $matches)) {
                     $this->_status = $matches[1];
                     continue;
Index: /branches/comu-ver2/data/module/Net/UserAgent/Mobile/NonMobile.php
===================================================================
--- /branches/comu-ver2/data/module/Net/UserAgent/Mobile/NonMobile.php	(revision 17140)
+++ /branches/comu-ver2/data/module/Net/UserAgent/Mobile/NonMobile.php	(revision 18188)
@@ -5,17 +5,34 @@
  * PHP versions 4 and 5
  *
- * LICENSE: This source file is subject to version 3.0 of the PHP license
- * that is available through the world-wide-web at the following URI:
- * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
- * the PHP License and are unable to obtain it through the web, please
- * send a note to license@php.net so we can mail you a copy immediately.
+ * Copyright (c) 2003-2009 KUBO Atsuhiro <kubo@iteman.jp>,
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *     * Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *     * Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in the
+ *       documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
  *
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2008 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
  * @version    CVS: $Id$
- * @see        Net_UserAgent_Mobile_Common
  * @since      File available since Release 0.1.0
  */
@@ -30,6 +47,6 @@
  *
  * Net_UserAgent_Mobile_NonMobile is a subclass of
- * {@link Net_UserAgent_Mobile_Common}, which implements non-mobile or
- * unimplemented user agents.
+ * {@link Net_UserAgent_Mobile_Common}, which implements non-mobile or unimplemented
+ * user agents.
  *
  * SYNOPSIS:
@@ -43,9 +60,8 @@
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2008 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
- * @version    Release: 0.31.0
- * @see        Net_UserAgent_Mobile_Common
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
+ * @version    Release: 1.0.0
  * @since      Class available since Release 0.1.0
  */
@@ -103,7 +119,5 @@
      * create a new {@link Net_UserAgent_Mobile_Display} class instance
      *
-     * @return object a newly created {@link Net_UserAgent_Mobile_Display}
-     *     object
-     * @see Net_UserAgent_Mobile_Display
+     * @return Net_UserAgent_Mobile_Display
      */
     function makeDisplay()
Index: /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Display.php
===================================================================
--- /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Display.php	(revision 17140)
+++ /branches/comu-ver2/data/module/Net/UserAgent/Mobile/Display.php	(revision 18188)
@@ -5,15 +5,33 @@
  * PHP versions 4 and 5
  *
- * LICENSE: This source file is subject to version 3.0 of the PHP license
- * that is available through the world-wide-web at the following URI:
- * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
- * the PHP License and are unable to obtain it through the web, please
- * send a note to license@php.net so we can mail you a copy immediately.
+ * Copyright (c) 2003-2009 KUBO Atsuhiro <kubo@iteman.jp>,
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *     * Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *     * Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in the
+ *       documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
  *
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2007 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
  * @version    CVS: $Id$
  * @since      File available since Release 0.1
@@ -49,6 +67,6 @@
  *
  * USING EXTERNAL MAP FILE:
- * If the environment variable DOCOMO_MAP exists, the specified XML data will
- * be used for DoCoMo display information.
+ * If the environment variable DOCOMO_MAP exists, the specified XML data will be used
+ * for DoCoMo display information.
  *
  * ex) Please add the following code.
@@ -57,8 +75,8 @@
  * @category   Networking
  * @package    Net_UserAgent_Mobile
- * @author     KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @copyright  2003-2007 KUBO Atsuhiro <iteman@users.sourceforge.net>
- * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
- * @version    Release: 0.31.0
+ * @author     KUBO Atsuhiro <kubo@iteman.jp>
+ * @copyright  2003-2009 KUBO Atsuhiro <kubo@iteman.jp>
+ * @license    http://www.opensource.org/licenses/bsd-license.php  New BSD License
+ * @version    Release: 1.0.0
  * @since      Class available since Release 0.1
  */
